Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class AsyncBoxView.ChildLocator

    java.lang.Object
      |
      +--javax.swing.text.AsyncBoxView.ChildLocator

Enclosing class:
  AsyncBoxView

public class AsyncBoxView.ChildLocator
extends Object

A class to manage the effective position of the child views in a localized area while changes are being made around the localized area. The AsyncBoxView may be continuously changing, but the visible area needs to remain fairly stable until the layout thread decides to publish an update to the parent.

Field Summary
`protected Rectangle` | `childAlloc` A shape to use for the child allocation to avoid creating a lot of garbage.
`protected Rectangle` | `lastAlloc` The last seen allocation (for repainting when changes are flushed upward).
`protected AsyncBoxView.ChildState` | `lastValidOffset` The location of the last offset calculation that is valid.

Constructor Summary
`AsyncBoxView.ChildLocator()` construct a child locator.

Method Summary
`void` | `childChanged(AsyncBoxView.ChildState cs)` Notification that a child changed.
`protected Shape` | `getChildAllocation(int index)` Fetch the allocation to use for a child view.
`Shape` | `getChildAllocation(int index, Shape a)` Fetch the allocation to use for a child view.
`int` | `getViewIndexAtPoint(float x, float y, Shape a)` Fetches the child view index at the given point.
`protected int` | `getViewIndexAtVisualOffset(float targetOffset)` Locate the view responsible for an offset into the box along the major axis.
`void` | `paintChildren(Graphics g)` Paint the children that intersect the clip area.
`protected void` | `setAllocation(Shape a)` Copy the currently allocated shape into the Rectangle used to store the current allocation.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### lastValidOffset

    protected AsyncBoxView.ChildState lastValidOffset

  The location of the last offset calculation that is valid.

### lastAlloc

    protected Rectangle lastAlloc

  The last seen allocation (for repainting when changes are flushed upward).

### childAlloc

    protected Rectangle childAlloc

  A shape to use for the child allocation to avoid creating a lot of garbage.

Constructor Detail

### AsyncBoxView.ChildLocator

    public AsyncBoxView.ChildLocator()

  construct a child locator.

Method Detail

### childChanged

    public void childChanged(AsyncBoxView.ChildState cs)

  Notification that a child changed. This can effect whether or not new offset calculations are needed. This is called by a ChildState object that has changed it's major span. This can therefore be called by multiple threads.

### paintChildren

    public void paintChildren(Graphics g)

  Paint the children that intersect the clip area.

### getChildAllocation

    public Shape getChildAllocation(int index,
                                    Shape a)

  Fetch the allocation to use for a child view. This will update the offsets for all children not yet updated before the given index.

### getViewIndexAtPoint

    public int getViewIndexAtPoint(float x,
                                   float y,
                                   Shape a)

  Fetches the child view index at the given point. This is called by the various View methods that need to calculate which child to forward a message to. This should be called by a block synchronized on this object, and would typically be followed with one or more calls to getChildAllocation that should also be in the synchronized block.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `a` - the allocation to the View
  Returns:
    the nearest child index

### getChildAllocation

    protected Shape getChildAllocation(int index)

  Fetch the allocation to use for a child view. This does not update the offsets in the ChildState records.

### setAllocation

    protected void setAllocation(Shape a)

  Copy the currently allocated shape into the Rectangle used to store the current allocation. This would be a floating point rectangle in a Java2D-specific implmentation.

### getViewIndexAtVisualOffset

    protected int getViewIndexAtVisualOffset(float targetOffset)

  Locate the view responsible for an offset into the box along the major axis. Make sure that offsets are set on the ChildState objects up to the given target span past the desired offset.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.